#ifndef __HELPER_H__
#define __HELPER_H__

#include "shaunlib.h"
#include "haplotype.h"
#include "model.h"
#include "parameters.h"
#include "driver.h"

class helper
{
 public:
    static void recodeSNPs(CSample &);
    static StringArray ACGT;
    static int  uSatLocusGivenSNP(Driver&,int,BoolArray&);
    static void calcUniqueReducedHaplotypeNum(BoolArray,int,IntArray&,int&,Driver&);
    static void calcUserReducedHaplotypeNum(vector<int>,int,IntArray&,int&);
    static void extractParameters(Model &);
    static void sub2fullMapping(Model,IntArray&);
    static void subFrequency(Model &,CVector&);
    static void sampleVariances(CSample &);
    static void summary(CSample &);
    static void collapsePhases(CVector&,CMatrix&,CMatrix&);
    static void usatFile(string,vector<int>&,vector< vector<int> >&,int);
    static void niceDumper(Driver&,CSample &);
    static string getHapName(Driver&, CHaplotype&);
    static double combinedEmpiricalPValue(vector<double>&,vector<double>&);
    
    class vpair
	{
	public:
	    CVector B;
	    CVector W;
	    
	    bool operator< (const vpair & rhs) const
		{
		    for (int i=1; i<=B.getCol();i++)
		    {
			if (B[i] < rhs.B[i]) return true;
			if (B[i] > rhs.B[i]) return false;
		    }
		    
		    for (int i=1; i<=W.getCol();i++)
		    {
			if (W[i] < rhs.W[i]) return true;
			if (W[i] > rhs.W[i]) return false;
		    }
		    
		    // otherwise they must be equal
		    return false;
		}
	    
	    bool operator== (const vpair & rhs) const
		{
		    if (B == rhs.B && W == rhs.W) 
			return true;
		    else
			return false;
		}
	    
	};

};

#endif
