#ifndef __WINDOW_H__
#define __WINDOW_H__

#include <vector>
#include "shaunlib.h"



class WindowResults
{
 public:
    WindowResults();

    // Storage of results 0=orig, 1+=perm
    vector<double> primary;
    vector< vector<double> > secondary;
};


class Window 
{
 public: 

    Window();
    
    // Number Window
    static int n;

    // Current Position along region in markers
    int pos;
    
    // Start, stop  position
    static int end;

    // Maximum span of alternate window
    static int size;

    // Vector of breakpoints
    static vector<int> gap;

    // Template for window under the alternate
    // e.g. 1,2,3,4,5
    vector<int> alt;

    // Template for window under the null
    // e.g. 1,2,4,5
    vector<int> null;

    WindowResults results;

};


#endif
